| Flutter Impeller |

Public Member Functions | List of all members
impeller::RectGeometry Class Referencefinal

`#include <rect_geometry.h>`

Inheritance diagram for impeller::RectGeometry:

## Public Member Functions
| RectGeometry (Rect rect)
| ~RectGeometry ()=default
bool | CoversArea (const Matrix &transform, const Rect &rect) const override
| Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`. More...
bool | IsAxisAlignedRect () const override
GeometryResult | GetPositionBuffer (const ContentContext &renderer, const Entity &entity, RenderPass &pass) const override
GeometryVertexType | GetVertexType () const override
std::optional< Rect > | GetCoverage (const Matrix &transform) const override
GeometryResult | GetPositionUVBuffer (Rect texture_coverage, Matrix effect_transform, const ContentContext &renderer, const Entity &entity, RenderPass &pass) const override
Public Member Functions inherited from impeller::Geometry
virtual GeometryResult::Mode | GetResultMode () const
virtual bool | CanApplyMaskFilter () const

## Additional Inherited Members
Static Public Member Functions inherited from impeller::Geometry
static std::shared_ptr< Geometry > | MakeFillPath (const Path &path, std::optional< Rect > inner_rect=std::nullopt)
static std::shared_ptr< Geometry > | MakeStrokePath (const Path &path, Scalar stroke_width=0.0, Scalar miter_limit=4.0, Cap stroke_cap=Cap::kButt, Join stroke_join=Join::kMiter)
static std::shared_ptr< Geometry > | MakeCover ()
static std::shared_ptr< Geometry > | MakeRect (const Rect &rect)
static std::shared_ptr< Geometry > | MakeOval (const Rect &rect)
static std::shared_ptr< Geometry > | MakeLine (const Point &p0, const Point &p1, Scalar width, Cap cap)
static std::shared_ptr< Geometry > | MakeCircle (const Point &center, Scalar radius)
static std::shared_ptr< Geometry > | MakeStrokedCircle (const Point &center, Scalar radius, Scalar stroke_width)
static std::shared_ptr< Geometry > | MakeRoundRect (const Rect &rect, const Size &radii)
static std::shared_ptr< Geometry > | MakePointField (std::vector< Point > points, Scalar radius, bool round)
Static Protected Member Functions inherited from impeller::Geometry
static GeometryResult | ComputePositionGeometry (const ContentContext &renderer, const Tessellator::VertexGenerator &generator, const Entity &entity, RenderPass &pass)
static GeometryResult | ComputePositionUVGeometry (const ContentContext &renderer, const Tessellator::VertexGenerator &generator, const Matrix &uv_transform, const Entity &entity, RenderPass &pass)

## Detailed Description

Definition at line 12 of file rect_geometry.h.

## Constructor & Destructor Documentation

## ◆ RectGeometry()

impeller::RectGeometry::RectGeometry | ( | Rect | rect | ) |
| explicit

Definition at line 9 of file rect_geometry.cc.

9 : rect_(rect) {}

## ◆ ~RectGeometry()

impeller::RectGeometry::~RectGeometry | ( |  | ) |
| default

## Member Function Documentation

## ◆ CoversArea()

bool impeller::RectGeometry::CoversArea | ( | const Matrix & | transform,
|  | const Rect & | rect
| ) |  | const
| override virtual

Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`.

This is a conservative estimate useful for certain optimizations.

Returns
  `true` if the transformed geometry is guaranteed to cover the given `rect`. May return `false` in many undetected cases where the transformed geometry does in fact cover the `rect`.

Reimplemented from impeller::Geometry.

Definition at line 46 of file rect_geometry.cc.

46 {
47 if (!transform.IsTranslationScaleOnly()) {
48 return false;
49 }
50 Rect coverage = rect_.TransformBounds(transform);
51 return coverage.Contains(rect);
52 }

References impeller::TRect< T >::Contains(), impeller::Matrix::IsTranslationScaleOnly(), and impeller::TRect< T >::TransformBounds().

## ◆ GetCoverage()

std::optional< Rect > impeller::RectGeometry::GetCoverage | ( | const Matrix & | transform | ) | const
| override virtual

Implements impeller::Geometry.

Definition at line 42 of file rect_geometry.cc.

42 {
43 return rect_.TransformBounds(transform);
44 }

References impeller::TRect< T >::TransformBounds().

## ◆ GetPositionBuffer()

GeometryResult impeller::RectGeometry::GetPositionBuffer | ( | const ContentContext & | renderer,
|  | const Entity & | entity,
|  | RenderPass & | pass
| ) |  | const
| override virtual

Implements impeller::Geometry.

Definition at line 11 of file rect_geometry.cc.

13 {
14 auto& host_buffer = renderer.GetTransientsBuffer();
15 return GeometryResult{
16 .type = PrimitiveType::kTriangleStrip,
17 .vertex_buffer =
18 {
19 .vertex_buffer = host_buffer.Emplace(
20 rect_.GetPoints().data(), 8 * sizeof(float), alignof(float)),
21 .vertex_count = 4,
22 .index_type = IndexType::kNone,
23 },
24 .transform = entity.GetShaderTransform(pass),
25 };
26 }

References impeller::TRect< T >::GetPoints(), impeller::Entity::GetShaderTransform(), impeller::ContentContext::GetTransientsBuffer(), impeller::kNone, impeller::kTriangleStrip, and impeller::GeometryResult::type.

## ◆ GetPositionUVBuffer()

GeometryResult impeller::RectGeometry::GetPositionUVBuffer | ( | Rect | texture_coverage,
|  | Matrix | effect_transform,
|  | const ContentContext & | renderer,
|  | const Entity & | entity,
|  | RenderPass & | pass
| ) |  | const
| override virtual

Implements impeller::Geometry.

Definition at line 29 of file rect_geometry.cc.

33 {
34 return ComputeUVGeometryForRect(rect_, texture_coverage, effect_transform,
35 renderer, entity, pass);
36 }

References impeller::ComputeUVGeometryForRect().

## ◆ GetVertexType()

GeometryVertexType impeller::RectGeometry::GetVertexType | ( |  | ) | const
| override virtual

Implements impeller::Geometry.

Definition at line 38 of file rect_geometry.cc.

38 {
39 return GeometryVertexType::kPosition;
40 }

References impeller::kPosition.

## ◆ IsAxisAlignedRect()

bool impeller::RectGeometry::IsAxisAlignedRect | ( |  | ) | const
| override virtual

Reimplemented from impeller::Geometry.

Definition at line 54 of file rect_geometry.cc.

54 {
55 return true;
56 }

The documentation for this class was generated from the following files:

- impeller/entity/geometry/rect_geometry.h
- impeller/entity/geometry/rect_geometry.cc

impeller::TRect::TransformBounds
constexpr TRect TransformBounds(const Matrix &transform) const
Creates a new bounding box that contains this transformed rectangle.
Definition: rect.h:405
impeller::TRect::GetPoints
constexpr std::array< TPoint< T >, 4 > GetPoints() const
Get the points that represent the 4 corners of this rectangle in a Z order that is compatible with tr...
Definition: rect.h:382
impeller::PrimitiveType::kTriangleStrip
@ kTriangleStrip
impeller::IndexType::kNone
@ kNone
Does not use the index buffer.
impeller::Rect
TRect< Scalar > Rect
Definition: rect.h:661
impeller::TRect::Contains
constexpr bool Contains(const TPoint< Type > &p) const
Returns true iff the provided point |p| is inside the half-open interior of this rectangle.
Definition: rect.h:217
impeller::ComputeUVGeometryForRect
GeometryResult ComputeUVGeometryForRect(Rect source_rect, Rect texture_bounds, Matrix effect_transform, const ContentContext &renderer, const Entity &entity, RenderPass &pass)
Computes geometry and UV coordinates for a rectangle to be rendered.
Definition: geometry.cc:113
impeller::kPosition
@ kPosition
Definition: geometry.h:50